/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus elle est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 120; // PTR pointe la première adresse qui suit la table du LOGO.

  TEXTE_a_inscrire_en_EEPROM = "HELIOS"; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "F6AAE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PATIENCE !  Calculs"; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Solstices-Equinoxe."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " Changer la DATE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " Jour / Mois / Annee"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Equinoxe Printmps"; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "Solstice Ete."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Equinoxe Automne."; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Solstice Hiver."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "> Jour simule. <"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "  Changer HEURE."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " HH  :  MM  :  SS"; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Longitude "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Latitude  "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = " Changer ALTITUDE."; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "1000 : 100  : 10 : 1"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "10.00000"; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Option des calculs"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Aurore / Crepuscule"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Mode : "; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Horizon &"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "correctn. refraction"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Civil."; Ecrire_Texte_en_EEPROM(); 
  TEXTE_a_inscrire_en_EEPROM = "Nautique."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Astronomique."; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "POSITION  ALT "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Culmine a "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Position du Soleil."; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Hauteur : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Azimut  : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Lever   : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Coucher : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "PILE de sauvegarde."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "E.T. le Heure d'"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "> VEILLE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Actualiser l'HORLOGE"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Fuite : B.P. court.  Modifier : B.P. long ----- PROCEDURE ----->> Changement voulu :>> Saisir HEURE puis >> B.P. au TOP radio."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Equation du temps."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Date : Jour : Nuit : hiver."; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "J Julien : "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "(3,3V nominal.)"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "B.P. long > Init HR"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Pile interne :    Vcc"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Accumulateur :    Vcc"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Jour Solaire :      s Calendrier Julien : Debut -4712 ans/ J.C.H Ete/Hiver  3 jours."; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1023) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
     EEPROM.write(PTR, 0); PTR++;
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
