/* Écriture des textes en EEPROM pour diminuer la place occupée dans la zone
   des variables dynamiques.
   Plus une chaire est longue, plus elle est "rentable". */

#include <EEPROM.h>

int PTR;
char Caractere;
String TEXTE_a_inscrire_en_EEPROM = ""; // Emplacement pour la chaîne entrante.

void setup() { Serial.begin(115200); 
  TEXTE_a_inscrire_en_EEPROM.reserve(30); } // 30 caractères sont très suffisants.

void loop() {  
  PTR = 120; // PTR pointe la première adresse qui suit la table du LOGO.

  TEXTE_a_inscrire_en_EEPROM = "HELIOSolstices-Equinoxe.F6AAEquinoxe PrintmpsPATIENCE !  CalculsSolstice Ete.Hiver.Equinoxe Automne.> Jour simule. <Changer la DATE.Longitude Horizon &"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "HH  :  MM  :  SSLatitude  Jour / Mois / AnneeMode :  Changer HEURE.ALTITUDE.1000 : 100  : 10 : 10.00000Option des calculsAurore / Crepusculecorrectn. refraction"; Ecrire_Texte_en_EEPROM();  
  TEXTE_a_inscrire_en_EEPROM = "Civil.Nautique.Astronomique.POSITION  ALT Culmine a Position du Soleil.Hauteur : Azimut  : Lever   : Coucher : PILE de sauvegarde.> VEILLEPoissonHeure d'"; Ecrire_Texte_en_EEPROM();
//TEXTE_a_inscrire_en_EEPROM = "Civil.Nautique.Astronomique.POSITION  ALT Culmine a Position du Soleil.Hauteur : Azimut  : Lever   : Coucher : PILE de sauvegarde.> VEILLE.T. le Heure d'"; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "Actualiser l'HORLOGEquation du temps.Fuite : B.P. court.  Modifier : B.P. long ----- PROCEDURE ----->> Changement voulu :>> Saisir HEURE puis >> B.P. au TOP radio."; Ecrire_Texte_en_EEPROM();
//TEXTE_a_inscrire_en_EEPROM = "Date : Jour : Nuit : hiver.J Julien : (3,3V nominal.)B.P. long > Init HRPile interne :    VccAccumulateurE.T. le Jour Solaire :      s Calendrier Julien :  Debut -4712 "; Ecrire_Texte_en_EEPROM();

  TEXTE_a_inscrire_en_EEPROM = "Date : Jour : Nuit : BelierJ Julien : (3,3V nominal.)B.P. long > Init HRPile interne :    VccAccumulateurE.T. le Jour Solaire :      s Calendrier Julien :  Debut -4712 "; Ecrire_Texte_en_EEPROM();
//TEXTE_a_inscrire_en_EEPROM = "Date : Jour : Nuit : ZZZZZZJ Julien : (3,3V nominal.)B.P. long > Init HRPile interne :    VccAccumulateurE.T. le Jour Solaire :      s Calendrier Julien :  Debut -4712 "; Ecrire_Texte_en_EEPROM();
  TEXTE_a_inscrire_en_EEPROM = "/ J.C.es diverses.TaureauGemauxCancerLionViergeBalanceScorpionOphiucusSagittaireCapricorneVerseau"; Ecrire_Texte_en_EEPROM();
  Lister_EEPROM();
  INFINI: goto INFINI; }
  
void Ecrire_Texte_en_EEPROM(){
  byte Curseur = 0; // Pointer le premier caractère du TEXTE.
  // Ne pas déborder la taille mémoire disponible en EEPROM.
  // N'envoyer que le TEXTE. */
  while ((PTR < 1023) && (TEXTE_a_inscrire_en_EEPROM[Curseur] != '\0')) {
     EEPROM.write(PTR, TEXTE_a_inscrire_en_EEPROM[Curseur]);
     Serial.print(TEXTE_a_inscrire_en_EEPROM[Curseur]); Curseur++; PTR++; }
     EEPROM.write(PTR, 0); PTR++;
  Serial.println(); }
  
void Lister_EEPROM() {
  PTR = 0;
  Lister_un_BLOC();Lister_un_BLOC();
  Lister_un_BLOC();Lister_un_BLOC(); }
  
void Lister_un_BLOC() {
  Lister_ENTETE();
  byte Compteur_lignes = 0;
  while (Compteur_lignes < 16)
    {Lister_une_LIGNE(); Compteur_lignes++; } }
  
void Lister_une_LIGNE() {   
  byte Compteur_Octets = 0; Serial.print(' ');
  if (PTR<10) {Serial.print('0');};
  if (PTR<100) {Serial.print('0');};
  if (PTR<1000) {Serial.print('0');};
  Serial.print(PTR); Serial.print("  ");  
  while (Compteur_Octets < 16) {
    Lister_OCTET(); Compteur_Octets++; }
  Serial.println(); }
  
void Lister_ENTETE() {
   Serial.println();
   Serial.println(" ADRS  00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F");}
   
void Lister_OCTET() {
  byte octet = EEPROM.read(PTR); 
  if ((octet > 31) && (octet < 126)) {Serial.print(' '); Serial.print(char(octet));}
  else Serial.print("..");
  Serial.print(' '); PTR++; }
